#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#define BUF_LEN 1024
/// Used to clear the buffer scanf reads from.
/// Useful when user enters malformed input, as scanf does not clear
/// when it fails to read an input.
#define READ_STDIN_UNTIL_NEWLINE() while (getchar() != '\n'){};


int cone_volume(float *volume, float radius, float height) {
  if (radius < 0.0 || height < 0.0) {
    return -1;
  }
  *volume = M_PI*radius*radius*height/3.0;
  return 0;
}

int cone_area(float *area, float radius, float height) {
  if (radius < 0.0 || height < 0.0) {
    return -1;
  }
  *area = M_PI*radius*(radius + sqrt(radius*radius + height*height));
  return 0;
}

int main() {
  int rc;
  float result, height, radius;
  char buf[BUF_LEN];

  do {
    printf("Enter radius of cone: ");
    rc = scanf("%f", &radius);
    READ_STDIN_UNTIL_NEWLINE();
  } while(rc != 1 && radius < 0.0);

  do {
    printf("Enter height of cone: ");
    rc = scanf("%f", &height);
    READ_STDIN_UNTIL_NEWLINE();
  } while(rc != 1 && height < 0.0);

  rc = cone_area(&result, radius, height);
  if(rc != 0) {
    printf("Unable to calculate surface area\n");
  } else {
    printf("Surface area: %.3f\n", result);
  }

  rc = cone_volume(&result, radius, height);
  if(rc != 0) {
    printf("Unable to calculate volume\n");
  } else {
    printf("Volume: %.3f\n", result);
  }
}
